part of '../../../store_management.dart';

class MeasureUnitModel extends NameModel<int> {
  static const String descriptionTag = "description";
  final String? description;
  static const String upMeasureUnitIdTag = "upMeasureUnitId";
  final int? upMeasureUnitId;

  const MeasureUnitModel({
    super.id = 0,
    required super.name,
    bool super.status = true,
    this.description,
    this.upMeasureUnitId,
  });
  MeasureUnitModel.fromMap(super.map)
      : description = map.getString(descriptionTag),
        upMeasureUnitId = map.getInt(upMeasureUnitIdTag),
        super.fromMap();

  @override
  Map<String, dynamic> toMap() => {
        ...super.toMap(),
        descriptionTag: description,
        upMeasureUnitIdTag: upMeasureUnitId,
      };
 
}

extension MeasureUnitModelExtension<ModelType extends MeasureUnitModel>
    on Iterable<ModelType> {
  ModelType? firstWhereByUpUnit(int? upMeasureUnitId) =>
      firstWhereOrNull((element) => element.upMeasureUnitId == upMeasureUnitId);
  ModelType? lastWhereByUpUnit(int? upMeasureUnitId) =>
      lastWhereOrNull((element) => element.upMeasureUnitId == upMeasureUnitId);

  Iterable<ModelType> whereByUpUnit(int? upMeasureUnitId) =>
      where((element) => element.upMeasureUnitId == upMeasureUnitId);
}
